import java.io.* ;
import java.net.* ;

class Peer
{
    PeerInfo me ;
    PeerInfo succ ;
    DatagramSocket channel ;
    
    public String toString ()
    {
	return me + "   succ: " + succ + "\n" ;
    }

    public void run ()
    {
	Message m = new Message () ;
	while (true) {
	    try {
		System.err.println (this) ;
		channel.receive (m.packet) ;
		System.err.println ("---- Receiving :\n" + m) ;
		//...
	    } catch (IOException e) { System.err.println (e) ; }
	}
    }

    void forwardMessage (Message m, PeerInfo nextHop)
    {
	short ttl = m.getTTL () ;
	if (ttl > 0) {
	    m.setTTL ((short)(ttl - 1)) ;
	    m.packet.setAddress (nextHop.addr) ;
	    m.packet.setPort (nextHop.port) ;
	    sendMessage (m) ;
	} // else throw the message

    }

    void sendMessage (Message m)
    {
	try {
	    System.err.println ("---- Sending :\n" + m) ;
	    synchronized (channel) {
		channel.send (m.packet) ;
	    }
	} catch (IOException e) { System.err.println (e) ; }
    }

    // true if l in [inf, sup[
    static boolean inInterval (long l, long inf, long sup)
    {
	if (inf < sup)
	    return (inf <= l) && (l < sup) ;
	else 
	    return (inf <= l) || (l < sup) ;
    }

    static long randomId ()
    {
	long high = randomInt () ;
	long low = randomInt () ;
	return (high << 32) | low ;
    }

    static long randomInt ()
    {
	long l = (long)(Math.random() * (((double)Integer.MAX_VALUE) * 2.0 + 1)) ;
	return l & 0xFFFFFFFFL ;
    }

}
